SuperLU: EXAMPLE/citersol1.c File Reference

SuperLU 7.0.0

Functions | Variables
citersol1.c File Reference
Example

Example #2 showing how to use ILU to precondition GMRES. More...

`#include "slu_cdefs.h"`
Include dependency graph for citersol1.c:

## Functions
void | cpsolve (int n, singlecomplex x[], singlecomplex y[])
| Performs CGSISX with original matrix A. More...
void | cmatvec_mult (singlecomplex alpha, singlecomplex x[], singlecomplex beta, singlecomplex y[])
| Performs matrix-vector multipliation sp_cgemv with original matrix A. More...
int | main (int argc, char *argv[])

## Variables
char * | GLOBAL_EQUED
superlu_options_t * | GLOBAL_OPTIONS
float * | GLOBAL_R
float * | GLOBAL_C
int * | GLOBAL_PERM_C
int * | GLOBAL_PERM_R
SuperMatrix * | GLOBAL_A
SuperMatrix * | GLOBAL_A_ORIG
SuperMatrix * | GLOBAL_L
SuperMatrix * | GLOBAL_U
SuperLUStat_t * | GLOBAL_STAT
mem_usage_t * | GLOBAL_MEM_USAGE

## Detailed Description

This example shows that ILU is computed from the equilibrated matrix, but the preconditioned GMRES is applied to the original system. The driver routine CGSISX is called twice to perform factorization and apply preconditioner separately.

Note that CGSISX performs the following factorization: Pr*Dr*A*Dc*Pc^T ~= LU with Pr being obtained from MC64 statically then partial pivoting dynamically. On return, A is overwritten as A1 = Dr*A*Dc.

We need to save a copy of the original matrix A, then solve the original system, A*x = B, using FGMRES. Each GMRES step requires requires 2 procedures: 1) Apply preconditioner M^{-1} = Dc*Pc^T*U^{-1}*L^{-1}*Pr*Dr 2) Matrix-vector multiplication: w = A*v

## Function Documentation

## ◆ cmatvec_mult()

void cmatvec_mult | ( | singlecomplex | alpha,
|  | singlecomplex | x[],
|  | singlecomplex | beta,
|  | singlecomplex | y[]
| ) |  |

The operations is y := alpha*A*x + beta*y. See documentation of sp_cgemv for further details.

Parameters

  [in] | alpha | Scalar factor for A*x
  [in] | x | Vector to multiply with A
  [in] | beta | Scalar factor for y
  [in,out] | y | Vector to add to to matrix-vector multiplication and storage for result.

Here is the call graph for this function:

## ◆ cpsolve()

void cpsolve | ( | int | n,
|  | singlecomplex | x[],
|  | singlecomplex | y[]
| ) |  |

See documentation of cgsisx for more details.

Parameters

  [in] | n | Dimension of matrices
  [out] | x | Solution
  [in,out] | y | Right-hand side

Here is the call graph for this function:

## ◆ main()

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Here is the call graph for this function:

## Variable Documentation

## ◆ GLOBAL_A

SuperMatrix* GLOBAL_A

## ◆ GLOBAL_A_ORIG

SuperMatrix * GLOBAL_A_ORIG

## ◆ GLOBAL_C

float * GLOBAL_C

## ◆ GLOBAL_EQUED

char* GLOBAL_EQUED

## ◆ GLOBAL_L

SuperMatrix * GLOBAL_L

## ◆ GLOBAL_MEM_USAGE

mem_usage_t* GLOBAL_MEM_USAGE

## ◆ GLOBAL_OPTIONS

superlu_options_t* GLOBAL_OPTIONS

## ◆ GLOBAL_PERM_C

int* GLOBAL_PERM_C

## ◆ GLOBAL_PERM_R

int * GLOBAL_PERM_R

## ◆ GLOBAL_R

float* GLOBAL_R

## ◆ GLOBAL_STAT

SuperLUStat_t* GLOBAL_STAT

## ◆ GLOBAL_U

SuperMatrix * GLOBAL_U